--- a/drivers/i2c/busses/i2c-viapro.c
+++ b/drivers/i2c/busses/i2c-viapro.c
@@ -135,7 +135,7 @@ static int vt596_transaction(u8 size)
 {
 	int temp;
 	int result = 0;
-	int timeout = 0;
+	unsigned long end_time;
 
 	vt596_dump_regs("Transaction (pre)", size);
 
@@ -156,13 +156,14 @@ static int vt596_transaction(u8 size)
 	outb_p(0x40 | size, SMBHSTCNT);
 
 	/* We will always wait for a fraction of a second */
+	end_time = jiffies + msecs_to_jiffies(MAX_TIMEOUT);
 	do {
 		msleep(1);
 		temp = inb_p(SMBHSTSTS);
-	} while ((temp & 0x01) && (timeout++ < MAX_TIMEOUT));
+	} while ((temp & 0x01) && time_before(jiffies, end_time));
 
 	/* If the SMBus is still busy, we give up */
-	if (timeout >= MAX_TIMEOUT) {
+	if (time_after_eq(jiffies, end_time)) {
 		result = -1;
 		dev_err(&vt596_adapter.dev, "SMBus timeout!\n");
 	}
--- a/drivers/ide/ide.c
+++ b/drivers/ide/ide.c
@@ -1041,7 +1041,7 @@ int ide_read_setting (ide_drive_t *drive
 
 int ide_spin_wait_hwgroup (ide_drive_t *drive)
 {
-	ide_hwgroup_t *hwgroup = HWGROUP(drive);
+	ide_hwgroup_t *hwgroup = drive->hwif->hwgroup;
 	unsigned long timeout = jiffies + (3 * HZ);
 
 	spin_lock_irq(&ide_lock);
@@ -1366,13 +1366,12 @@ int generic_ide_ioctl(ide_drive_t *drive
 
 			ide_abort(drive, "drive reset");
 
-			if(HWGROUP(drive)->handler)
-				BUG();
+			BUG_ON(drive->hwif->hwgroup->handler);
 				
 			/* Ensure nothing gets queued after we
 			   drop the lock. Reset will clear the busy */
 		   
-			HWGROUP(drive)->busy = 1;
+			drive->hwif->hwgroup->busy = 1;
 			spin_unlock_irqrestore(&ide_lock, flags);
 			(void) ide_do_reset(drive);
 
--- a/drivers/ide/ide-cd.c
+++ b/drivers/ide/ide-cd.c
@@ -591,7 +591,7 @@ static void cdrom_queue_request_sense(id
 
 static void cdrom_end_request (ide_drive_t *drive, int uptodate)
 {
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 	int nsectors = rq->hard_cur_sectors;
 
 	if ((rq->flags & REQ_SENSE) && uptodate) {
@@ -637,7 +637,7 @@ static void cdrom_end_request (ide_drive
    Returns 1 if the request was ended. */
 static int cdrom_decode_status(ide_drive_t *drive, int good_stat, int *stat_ret)
 {
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 	int stat, err, sense_key;
 	
 	/* Check for errors. */
@@ -701,7 +701,7 @@ static int cdrom_decode_status(ide_drive
 		if (stat & ERR_STAT) {
 			spin_lock_irqsave(&ide_lock, flags);
 			blkdev_dequeue_request(rq);
-			HWGROUP(drive)->rq = NULL;
+			drive->hwif->hwgroup->rq = NULL;
 			spin_unlock_irqrestore(&ide_lock, flags);
 
 			cdrom_queue_request_sense(drive, rq->sense, rq);
@@ -800,7 +800,7 @@ static int cdrom_decode_status(ide_drive
 
 static int cdrom_timer_expiry(ide_drive_t *drive)
 {
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 	unsigned long wait = 0;
 
 	/*
@@ -1025,7 +1025,7 @@ static ide_startstop_t cdrom_read_intr (
 	u8 lowcyl = 0, highcyl = 0;
 	int dma = info->dma, dma_error = 0;
 
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 
 	/*
 	 * handle dma case
@@ -1152,7 +1152,7 @@ static ide_startstop_t cdrom_read_intr (
 static int cdrom_read_from_buffer (ide_drive_t *drive)
 {
 	struct cdrom_info *info = drive->driver_data;
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 	unsigned short sectors_per_frame;
 
 	sectors_per_frame = queue_hardsect_size(drive->queue) >> SECTOR_BITS;
@@ -1212,7 +1212,7 @@ static int cdrom_read_from_buffer (ide_d
  */
 static ide_startstop_t cdrom_start_read_continuation (ide_drive_t *drive)
 {
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 	unsigned short sectors_per_frame;
 	int nskip;
 
@@ -1275,7 +1275,7 @@ static ide_startstop_t cdrom_seek_intr (
 
 static ide_startstop_t cdrom_start_seek_continuation (ide_drive_t *drive)
 {
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 	sector_t frame = rq->sector;
 
 	sector_div(frame, queue_hardsect_size(drive->queue) >> SECTOR_BITS);
@@ -1320,7 +1320,7 @@ static void restore_request (struct requ
 static ide_startstop_t cdrom_start_read (ide_drive_t *drive, unsigned int block)
 {
 	struct cdrom_info *info = drive->driver_data;
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 	unsigned short sectors_per_frame;
 
 	sectors_per_frame = queue_hardsect_size(drive->queue) >> SECTOR_BITS;
@@ -1354,7 +1354,7 @@ static ide_startstop_t cdrom_start_read 
 static ide_startstop_t cdrom_pc_intr (ide_drive_t *drive)
 {
 	int ireason, len, thislen;
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 	u8 lowcyl = 0, highcyl = 0;
 	int stat;
 
@@ -1463,7 +1463,7 @@ confused:
 
 static ide_startstop_t cdrom_do_pc_continuation (ide_drive_t *drive)
 {
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 
 	if (!rq->timeout)
 		rq->timeout = ATAPI_WAIT_PC;
@@ -1476,7 +1476,7 @@ static ide_startstop_t cdrom_do_pc_conti
 static ide_startstop_t cdrom_do_packet_command (ide_drive_t *drive)
 {
 	int len;
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 	struct cdrom_info *info = drive->driver_data;
 
 	info->dma = 0;
@@ -1604,7 +1604,7 @@ typedef void (xfer_func_t)(ide_drive_t *
 static ide_startstop_t cdrom_newpc_intr(ide_drive_t *drive)
 {
 	struct cdrom_info *info = drive->driver_data;
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 	int dma_error, dma, stat, ireason, len, thislen;
 	u8 lowcyl, highcyl;
 	xfer_func_t *xferfunc;
@@ -1722,9 +1722,6 @@ static ide_startstop_t cdrom_newpc_intr(
 		}
 	}
 
-	if (HWGROUP(drive)->handler != NULL)
-		BUG();
-
 	ide_set_handler(drive, cdrom_newpc_intr, rq->timeout, NULL);
 	return ide_started;
 
@@ -1735,7 +1732,7 @@ end_request:
 	spin_lock_irqsave(&ide_lock, flags);
 	blkdev_dequeue_request(rq);
 	end_that_request_last(rq, 1);
-	HWGROUP(drive)->rq = NULL;
+	drive->hwif->hwgroup->rq = NULL;
 	spin_unlock_irqrestore(&ide_lock, flags);
 	return ide_stopped;
 }
@@ -1747,7 +1744,7 @@ static ide_startstop_t cdrom_write_intr(
 	int dma_error = 0, dma = info->dma;
 	u8 lowcyl = 0, highcyl = 0;
 
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 
 	/* Check for errors. */
 	if (dma) {
@@ -1840,7 +1837,7 @@ static ide_startstop_t cdrom_write_intr(
 
 static ide_startstop_t cdrom_start_write_cont(ide_drive_t *drive)
 {
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 
 #if 0	/* the immediate bit */
 	rq->cmd[1] = 1 << 3;
@@ -1887,7 +1884,7 @@ static ide_startstop_t cdrom_start_write
 
 static ide_startstop_t cdrom_do_newpc_cont(ide_drive_t *drive)
 {
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 
 	if (!rq->timeout)
 		rq->timeout = ATAPI_WAIT_PC;
--- a/drivers/ide/ide-dma.c
+++ b/drivers/ide/ide-dma.c
@@ -170,7 +170,7 @@ ide_startstop_t ide_dma_intr (ide_drive_
 	stat = HWIF(drive)->INB(IDE_STATUS_REG);	/* get drive status */
 	if (OK_STAT(stat,DRIVE_READY,drive->bad_wstat|DRQ_STAT)) {
 		if (!dma_stat) {
-			struct request *rq = HWGROUP(drive)->rq;
+			struct request *rq = drive->hwif->hwgroup->rq;
 
 			if (rq->rq_disk) {
 				ide_driver_t *drv;
@@ -206,8 +206,7 @@ int ide_build_sglist(ide_drive_t *drive,
 	ide_hwif_t *hwif = HWIF(drive);
 	struct scatterlist *sg = hwif->sg_table;
 
-	if ((rq->flags & REQ_DRIVE_TASKFILE) && rq->nr_sectors > 256)
-		BUG();
+	BUG_ON((rq->flags & REQ_DRIVE_TASKFILE) && rq->nr_sectors > 256);
 
 	ide_map_sg(drive, rq);
 
@@ -403,7 +402,7 @@ static int dma_timer_expiry (ide_drive_t
 	if ((dma_stat & 0x18) == 0x18)	/* BUSY Stupid Early Timer !! */
 		return WAIT_CMD;
 
-	HWGROUP(drive)->expiry = NULL;	/* one free ride for now */
+	drive->hwif->hwgroup->expiry = NULL;	/* one free ride for now */
 
 	/* 1 dmaing, 2 error, 4 intr */
 	if (dma_stat & 2)	/* ERROR */
@@ -553,7 +552,7 @@ EXPORT_SYMBOL(__ide_dma_check);
 int ide_dma_setup(ide_drive_t *drive)
 {
 	ide_hwif_t *hwif = drive->hwif;
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 	unsigned int reading;
 	u8 dma_stat;
 
@@ -947,8 +946,7 @@ void ide_setup_dma (ide_hwif_t *hwif, un
 	}
 	printk("\n");
 
-	if (!(hwif->dma_master))
-		BUG();
+	BUG_ON(!(hwif->dma_master));
 }
 
 EXPORT_SYMBOL_GPL(ide_setup_dma);
--- a/drivers/ide/ide-floppy.c
+++ b/drivers/ide/ide-floppy.c
@@ -574,7 +574,7 @@ static void idefloppy_write_zeros (ide_d
 static int idefloppy_do_end_request(ide_drive_t *drive, int uptodate, int nsecs)
 {
 	idefloppy_floppy_t *floppy = drive->driver_data;
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 	int error;
 
 	debug_log(KERN_INFO "Reached idefloppy_end_request\n");
@@ -898,8 +898,6 @@ static ide_startstop_t idefloppy_pc_intr
 					"to send us more data than expected "
 					"- discarding data\n");
 				idefloppy_discard_data(drive,bcount.all);
-				if (HWGROUP(drive)->handler != NULL)
-					BUG();
 				ide_set_handler(drive,
 						&idefloppy_pc_intr,
 						IDEFLOPPY_WAIT_CMD,
@@ -932,8 +930,6 @@ static ide_startstop_t idefloppy_pc_intr
 	pc->actually_transferred += bcount.all;
 	pc->current_position += bcount.all;
 
-	if (HWGROUP(drive)->handler != NULL)
-		BUG();
 	ide_set_handler(drive, &idefloppy_pc_intr, IDEFLOPPY_WAIT_CMD, NULL);		/* And set the interrupt handler again */
 	return ide_started;
 }
@@ -960,8 +956,6 @@ static ide_startstop_t idefloppy_transfe
 				"issuing a packet command\n");
 		return ide_do_reset(drive);
 	}
-	if (HWGROUP(drive)->handler != NULL)
-		BUG();
 	/* Set the interrupt routine */
 	ide_set_handler(drive, &idefloppy_pc_intr, IDEFLOPPY_WAIT_CMD, NULL);
 	/* Send the actual packet */
@@ -1017,8 +1011,6 @@ static ide_startstop_t idefloppy_transfe
 	 * 40 and 50msec work well. idefloppy_pc_intr will not be actually
 	 * used until after the packet is moved in about 50 msec.
 	 */
-	if (HWGROUP(drive)->handler != NULL)
-		BUG();
 	ide_set_handler(drive, 
 	  &idefloppy_pc_intr, 		/* service routine for packet command */
 	  floppy->ticks,		/* wait this long before "failing" */
--- a/drivers/ide/ide-io.c
+++ b/drivers/ide/ide-io.c
@@ -78,13 +78,13 @@ static int __ide_end_request(ide_drive_t
 	 */
 	if (drive->state == DMA_PIO_RETRY && drive->retry_pio <= 3) {
 		drive->state = 0;
-		HWGROUP(drive)->hwif->ide_dma_on(drive);
+		drive->hwif->hwgroup->hwif->ide_dma_on(drive);
 	}
 
 	if (!end_that_request_first(rq, uptodate, nr_sectors)) {
 		add_disk_randomness(rq->rq_disk);
 		blkdev_dequeue_request(rq);
-		HWGROUP(drive)->rq = NULL;
+		drive->hwif->hwgroup->rq = NULL;
 		end_that_request_last(rq, uptodate);
 		ret = 0;
 	}
@@ -114,7 +114,7 @@ int ide_end_request (ide_drive_t *drive,
 	 * need the queue lock held at all
 	 */
 	spin_lock_irqsave(&ide_lock, flags);
-	rq = HWGROUP(drive)->rq;
+	rq = drive->hwif->hwgroup->rq;
 
 	if (!nr_sectors)
 		nr_sectors = rq->hard_cur_sectors;
@@ -243,7 +243,7 @@ static void ide_complete_pm_request (ide
 		blk_start_queue(drive->queue);
 	}
 	blkdev_dequeue_request(rq);
-	HWGROUP(drive)->rq = NULL;
+	drive->hwif->hwgroup->rq = NULL;
 	end_that_request_last(rq, 1);
 	spin_unlock_irqrestore(&ide_lock, flags);
 }
@@ -304,7 +304,7 @@ void ide_end_drive_cmd (ide_drive_t *dri
 	struct request *rq;
 
 	spin_lock_irqsave(&ide_lock, flags);
-	rq = HWGROUP(drive)->rq;
+	rq = drive->hwif->hwgroup->rq;
 	spin_unlock_irqrestore(&ide_lock, flags);
 
 	if (rq->flags & REQ_DRIVE_CMD) {
@@ -374,7 +374,7 @@ void ide_end_drive_cmd (ide_drive_t *dri
 
 	spin_lock_irqsave(&ide_lock, flags);
 	blkdev_dequeue_request(rq);
-	HWGROUP(drive)->rq = NULL;
+	drive->hwif->hwgroup->rq = NULL;
 	rq->errors = err;
 	end_that_request_last(rq, !rq->errors);
 	spin_unlock_irqrestore(&ide_lock, flags);
@@ -523,7 +523,7 @@ ide_startstop_t ide_error (ide_drive_t *
 
 	err = ide_dump_status(drive, msg, stat);
 
-	if ((rq = HWGROUP(drive)->rq) == NULL)
+	if ((rq = drive->hwif->hwgroup->rq) == NULL)
 		return ide_stopped;
 
 	/* retry only "normal" I/O: */
@@ -574,7 +574,7 @@ ide_startstop_t ide_abort(ide_drive_t *d
 {
 	struct request *rq;
 
-	if (drive == NULL || (rq = HWGROUP(drive)->rq) == NULL)
+	if (drive == NULL || (rq = drive->hwif->hwgroup->rq) == NULL)
 		return ide_stopped;
 
 	/* retry only "normal" I/O: */
@@ -627,7 +627,7 @@ static void ide_cmd (ide_drive_t *drive,
  
 static ide_startstop_t drive_cmd_intr (ide_drive_t *drive)
 {
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 	ide_hwif_t *hwif = HWIF(drive);
 	u8 *args = (u8 *) rq->buffer;
 	u8 stat = hwif->INB(IDE_STATUS_REG);
@@ -1235,7 +1235,7 @@ void do_ide_request(request_queue_t *q)
 {
 	ide_drive_t *drive = q->queuedata;
 
-	ide_do_request(HWGROUP(drive), IDE_NO_IRQ);
+	ide_do_request(drive->hwif->hwgroup, IDE_NO_IRQ);
 }
 
 /*
@@ -1276,8 +1276,8 @@ static ide_startstop_t ide_dma_timeout_r
 	 * un-busy drive etc (hwgroup->busy is cleared on return) and
 	 * make sure request is sane
 	 */
-	rq = HWGROUP(drive)->rq;
-	HWGROUP(drive)->rq = NULL;
+	rq = drive->hwif->hwgroup->rq;
+	drive->hwif->hwgroup->rq = NULL;
 
 	rq->errors = 0;
 
@@ -1635,7 +1635,7 @@ EXPORT_SYMBOL(ide_init_drive_cmd);
 int ide_do_drive_cmd (ide_drive_t *drive, struct request *rq, ide_action_t action)
 {
 	unsigned long flags;
-	ide_hwgroup_t *hwgroup = HWGROUP(drive);
+	ide_hwgroup_t *hwgroup = drive->hwif->hwgroup;
 	DECLARE_COMPLETION(wait);
 	int where = ELEVATOR_INSERT_BACK, err;
 	int must_wait = (action == ide_wait || action == ide_head_wait);
--- a/drivers/ide/ide-iops.c
+++ b/drivers/ide/ide-iops.c
@@ -768,7 +768,7 @@ int ide_config_drive_speed (ide_drive_t 
 	int	i, error	= 1;
 	u8 stat;
 
-//	while (HWGROUP(drive)->busy)
+//	while (drive->hwif->hwgroup->busy)
 //		msleep(50);
 
 #ifdef CONFIG_BLK_DEV_IDEDMA
@@ -893,12 +893,13 @@ EXPORT_SYMBOL(ide_config_drive_speed);
 static void __ide_set_handler (ide_drive_t *drive, ide_handler_t *handler,
 		      unsigned int timeout, ide_expiry_t *expiry)
 {
-	ide_hwgroup_t *hwgroup = HWGROUP(drive);
+	ide_hwgroup_t *hwgroup = drive->hwif->hwgroup;
 
 	if (hwgroup->handler != NULL) {
 		printk(KERN_CRIT "%s: ide_set_handler: handler not null; "
 			"old=%p, new=%p\n",
 			drive->name, hwgroup->handler, handler);
+			BUG();
 	}
 	hwgroup->handler	= handler;
 	hwgroup->expiry		= expiry;
@@ -934,13 +935,12 @@ EXPORT_SYMBOL(ide_set_handler);
 void ide_execute_command(ide_drive_t *drive, task_ioreg_t cmd, ide_handler_t *handler, unsigned timeout, ide_expiry_t *expiry)
 {
 	unsigned long flags;
-	ide_hwgroup_t *hwgroup = HWGROUP(drive);
+	ide_hwgroup_t *hwgroup = drive->hwif->hwgroup;
 	ide_hwif_t *hwif = HWIF(drive);
 	
 	spin_lock_irqsave(&ide_lock, flags);
 	
-	if(hwgroup->handler)
-		BUG();
+	BUG_ON(hwgroup->handler);
 	hwgroup->handler	= handler;
 	hwgroup->expiry		= expiry;
 	hwgroup->timer.expires	= jiffies + timeout;
@@ -970,7 +970,7 @@ static ide_startstop_t do_reset1 (ide_dr
  */
 static ide_startstop_t atapi_reset_pollfunc (ide_drive_t *drive)
 {
-	ide_hwgroup_t *hwgroup	= HWGROUP(drive);
+	ide_hwgroup_t *hwgroup	= drive->hwif->hwgroup;
 	ide_hwif_t *hwif	= HWIF(drive);
 	u8 stat;
 
@@ -981,8 +981,6 @@ static ide_startstop_t atapi_reset_pollf
 		printk("%s: ATAPI reset complete\n", drive->name);
 	} else {
 		if (time_before(jiffies, hwgroup->poll_timeout)) {
-			if (HWGROUP(drive)->handler != NULL)
-				BUG();
 			ide_set_handler(drive, &atapi_reset_pollfunc, HZ/20, NULL);
 			/* continue polling */
 			return ide_started;
@@ -1007,7 +1005,7 @@ static ide_startstop_t atapi_reset_pollf
  */
 static ide_startstop_t reset_pollfunc (ide_drive_t *drive)
 {
-	ide_hwgroup_t *hwgroup	= HWGROUP(drive);
+	ide_hwgroup_t *hwgroup	= drive->hwif->hwgroup;
 	ide_hwif_t *hwif	= HWIF(drive);
 	u8 tmp;
 
@@ -1021,8 +1019,6 @@ static ide_startstop_t reset_pollfunc (i
 
 	if (!OK_STAT(tmp = hwif->INB(IDE_STATUS_REG), 0, BUSY_STAT)) {
 		if (time_before(jiffies, hwgroup->poll_timeout)) {
-			if (HWGROUP(drive)->handler != NULL)
-				BUG();
 			ide_set_handler(drive, &reset_pollfunc, HZ/20, NULL);
 			/* continue polling */
 			return ide_started;
@@ -1135,11 +1131,10 @@ static ide_startstop_t do_reset1 (ide_dr
 	
 	spin_lock_irqsave(&ide_lock, flags);
 	hwif = HWIF(drive);
-	hwgroup = HWGROUP(drive);
+	hwgroup = drive->hwif->hwgroup;
 
 	/* We must not reset with running handlers */
-	if(hwgroup->handler != NULL)
-		BUG();
+	BUG_ON(hwgroup->handler != NULL);
 
 	/* For an ATAPI device, first try an ATAPI SRST. */
 	if (drive->media != ide_disk && !do_not_try_atapi) {
--- a/drivers/ide/ide-lib.c
+++ b/drivers/ide/ide-lib.c
@@ -164,8 +164,7 @@ u8 ide_rate_filter (u8 mode, u8 speed) 
 //	printk("%s: mode 0x%02x, speed 0x%02x\n", __FUNCTION__, mode, speed);
 
 	/* So that we remember to update this if new modes appear */
-	if (mode > 4)
-		BUG();
+	BUG_ON(mode > 4);
 	return min(speed, speed_max[mode]);
 #else /* !CONFIG_BLK_DEV_IDEDMA */
 	return min(speed, (u8)XFER_PIO_4);
@@ -453,8 +452,8 @@ static void ide_dump_opcode(ide_drive_t 
 
 	spin_lock(&ide_lock);
 	rq = NULL;
-	if (HWGROUP(drive))
-		rq = HWGROUP(drive)->rq;
+	if (drive->hwif->hwgroup)
+		rq = drive->hwif->hwgroup->rq;
 	spin_unlock(&ide_lock);
 	if (!rq)
 		return;
@@ -539,9 +538,10 @@ static u8 ide_dump_ata_status(ide_drive_
 					  hwif->INB(IDE_SECTOR_REG));
 				}
 			}
-			if (HWGROUP(drive) && HWGROUP(drive)->rq)
+			if (drive->hwif->hwgroup && drive->hwif->hwgroup->rq)
 				printk(", sector=%llu",
-					(unsigned long long)HWGROUP(drive)->rq->sector);
+					(unsigned long long)
+					drive->hwif->hwgroup->rq->sector);
 		}
 		printk("\n");
 	}
--- a/drivers/ide/ide-tape.c
+++ b/drivers/ide/ide-tape.c
@@ -1682,7 +1682,7 @@ static void idetape_abort_pipeline(ide_d
  */
 static int idetape_end_request(ide_drive_t *drive, int uptodate, int nr_sects)
 {
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 	idetape_tape_t *tape = drive->driver_data;
 	unsigned long flags;
 	int error;
@@ -1845,7 +1845,7 @@ static void idetape_postpone_request (id
 	if (tape->debug_level >= 4)
 		printk(KERN_INFO "ide-tape: idetape_postpone_request\n");
 #endif
-	tape->postponed_rq = HWGROUP(drive)->rq;
+	tape->postponed_rq = drive->hwif->hwgroup->rq;
 	ide_stall_queue(drive, tape->dsc_polling_frequency);
 }
 
@@ -2323,7 +2323,7 @@ static ide_startstop_t idetape_media_acc
 static ide_startstop_t idetape_rw_callback (ide_drive_t *drive)
 {
 	idetape_tape_t *tape = drive->driver_data;
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 	int blocks = tape->pc->actually_transferred / tape->tape_block_size;
 
 	tape->avg_size += blocks * tape->tape_block_size;
--- a/drivers/ide/ide-taskfile.c
+++ b/drivers/ide/ide-taskfile.c
@@ -196,8 +196,6 @@ ide_startstop_t set_geometry_intr (ide_d
 	if (stat & (ERR_STAT|DRQ_STAT))
 		return ide_error(drive, "set_geometry_intr", stat);
 
-	if (HWGROUP(drive)->handler != NULL)
-		BUG();
 	ide_set_handler(drive, &set_geometry_intr, WAIT_WORSTCASE, NULL);
 	return ide_started;
 }
@@ -220,7 +218,7 @@ ide_startstop_t recal_intr (ide_drive_t 
  */
 ide_startstop_t task_no_data_intr (ide_drive_t *drive)
 {
-	ide_task_t *args	= HWGROUP(drive)->rq->special;
+	ide_task_t *args	= drive->hwif->hwgroup->rq->special;
 	ide_hwif_t *hwif	= HWIF(drive);
 	u8 stat;
 
@@ -390,7 +388,7 @@ static void task_end_request(ide_drive_t
 ide_startstop_t task_in_intr (ide_drive_t *drive)
 {
 	ide_hwif_t *hwif = drive->hwif;
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 	u8 stat = hwif->INB(IDE_STATUS_REG);
 
 	/* new way for dealing with premature shared PCI interrupts */
@@ -426,7 +424,7 @@ EXPORT_SYMBOL(task_in_intr);
 static ide_startstop_t task_out_intr (ide_drive_t *drive)
 {
 	ide_hwif_t *hwif = drive->hwif;
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 	u8 stat = hwif->INB(IDE_STATUS_REG);
 
 	if (!OK_STAT(stat, DRIVE_READY, drive->bad_wstat))
--- a/drivers/ide/legacy/hd.c
+++ b/drivers/ide/legacy/hd.c
@@ -456,11 +456,6 @@ ok_to_read:
 	req->errors = 0;
 	i = --req->nr_sectors;
 	--req->current_nr_sectors;
-#ifdef DEBUG
-	printk("%s: read: sector %ld, remaining = %ld, buffer=%p\n",
-		req->rq_disk->disk_name, req->sector, req->nr_sectors,
-		req->buffer+512));
-#endif
 	if (req->current_nr_sectors <= 0)
 		end_request(req, 1);
 	if (i > 0) {
@@ -542,12 +537,8 @@ static void hd_times_out(unsigned long d
 	reset = 1;
 	name = CURRENT->rq_disk->disk_name;
 	printk("%s: timeout\n", name);
-	if (++CURRENT->errors >= MAX_ERRORS) {
-#ifdef DEBUG
-		printk("%s: too many errors\n", name);
-#endif
+	if (++CURRENT->errors >= MAX_ERRORS)
 		end_request(CURRENT, 0);
-	}
 	local_irq_disable();
 	hd_request();
 	enable_irq(HD_IRQ);
@@ -621,11 +612,6 @@ repeat:
 	track = block / disk->sect;
 	head  = track % disk->head;
 	cyl   = track / disk->head;
-#ifdef DEBUG
-	printk("%s: %sing: CHS=%d/%d/%d, sectors=%d, buffer=%p\n",
-		req->rq_disk->disk_name, (req->cmd == READ)?"read":"writ",
-		cyl, head, sec, nsect, req->buffer);
-#endif
 	if (req->flags & REQ_CMD) {
 		switch (rq_data_dir(req)) {
 		case READ:
--- a/drivers/ide/mips/au1xxx-ide.c
+++ b/drivers/ide/mips/au1xxx-ide.c
@@ -273,7 +273,7 @@ static int auide_build_dmatable(ide_driv
 	int i, iswrite, count = 0;
 	ide_hwif_t *hwif = HWIF(drive);
 
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 
 	_auide_hwif *ahwif = (_auide_hwif*)hwif->hwif_data;
 	struct scatterlist *sg;
@@ -379,7 +379,7 @@ static void auide_dma_exec_cmd(ide_drive
 
 static int auide_dma_setup(ide_drive_t *drive)
 {       	
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 
 	if (!auide_build_dmatable(drive)) {
 		ide_map_sg(drive, rq);
--- a/drivers/ide/pci/pdc202xx_old.c
+++ b/drivers/ide/pci/pdc202xx_old.c
@@ -413,7 +413,7 @@ static void pdc202xx_old_ide_dma_start(i
 	if (drive->current_speed > XFER_UDMA_2)
 		pdc_old_enable_66MHz_clock(drive->hwif);
 	if (drive->addressing == 1) {
-		struct request *rq	= HWGROUP(drive)->rq;
+		struct request *rq	= drive->hwif->hwgroup->rq;
 		ide_hwif_t *hwif	= HWIF(drive);
 //		struct pci_dev *dev	= hwif->pci_dev;
 //		unsgned long high_16	= pci_resource_start(dev, 4);
--- a/drivers/ide/pci/sgiioc4.c
+++ b/drivers/ide/pci/sgiioc4.c
@@ -547,7 +547,7 @@ use_pio_instead:
 
 static int sgiioc4_ide_dma_setup(ide_drive_t *drive)
 {
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 	unsigned int count = 0;
 	int ddir;
 
--- a/drivers/ide/pci/siimage.c
+++ b/drivers/ide/pci/siimage.c
@@ -474,7 +474,7 @@ static int siimage_io_ide_dma_test_irq (
 static int siimage_mmio_ide_dma_count (ide_drive_t *drive)
 {
 #ifdef SIIMAGE_VIRTUAL_DMAPIO
-	struct request *rq	= HWGROUP(drive)->rq;
+	struct request *rq	= drive->hwif->hwgroup->rq;
 	ide_hwif_t *hwif	= HWIF(drive);
 	u32 count		= (rq->nr_sectors * SECTOR_SIZE);
 	u32 rcount		= 0;
@@ -596,7 +596,7 @@ static int siimage_reset_poll (ide_drive
 		if ((hwif->INL(SATA_STATUS_REG) & 0x03) != 0x03) {
 			printk(KERN_WARNING "%s: reset phy dead, status=0x%08x\n",
 				hwif->name, hwif->INL(SATA_STATUS_REG));
-			HWGROUP(drive)->polling = 0;
+			drive->hwif->hwgroup->polling = 0;
 			return ide_started;
 		}
 		return 0;
--- a/drivers/ide/pci/trm290.c
+++ b/drivers/ide/pci/trm290.c
@@ -183,8 +183,6 @@ static void trm290_ide_dma_exec_cmd(ide_
 {
 	ide_hwif_t *hwif	= HWIF(drive);
 
-	if (HWGROUP(drive)->handler != NULL)	/* paranoia check */
-		BUG();
 	ide_set_handler(drive, &ide_dma_intr, WAIT_CMD, NULL);
 	/* issue cmd to drive */
 	hwif->OUTB(command, IDE_COMMAND_REG);
--- a/drivers/ide/ppc/pmac.c
+++ b/drivers/ide/ppc/pmac.c
@@ -1966,7 +1966,7 @@ pmac_ide_dma_setup(ide_drive_t *drive)
 {
 	ide_hwif_t *hwif = HWIF(drive);
 	pmac_ide_hwif_t* pmif = (pmac_ide_hwif_t *)hwif->hwif_data;
-	struct request *rq = HWGROUP(drive)->rq;
+	struct request *rq = drive->hwif->hwgroup->rq;
 	u8 unit = (drive->select.b.unit & 0x01);
 	u8 ata4;
 
--- a/drivers/infiniband/hw/mthca/mthca_reset.c
+++ b/drivers/infiniband/hw/mthca/mthca_reset.c
@@ -153,9 +153,10 @@ int mthca_reset(struct mthca_dev *mdev)
 	/* Now wait for PCI device to start responding again */
 	{
 		u32 v;
-		int c = 0;
+		unsigned long end_time;
 
-		for (c = 0; c < 100; ++c) {
+		end_time = jiffies + msecs_to_jiffies(10000);
+		while (time_before(jiffies, end_time)) {
 			if (pci_read_config_dword(bridge ? bridge : mdev->pdev, 0, &v)) {
 				err = -ENODEV;
 				mthca_err(mdev, "Couldn't access HCA after reset, "
--- a/drivers/input/joystick/analog.c
+++ b/drivers/input/joystick/analog.c
@@ -576,6 +576,7 @@ static int analog_init_masks(struct anal
 static int analog_init_port(struct gameport *gameport, struct gameport_driver *drv, struct analog_port *port)
 {
 	int i, t, u, v;
+	unsigned long end_time;
 
 	port->gameport = gameport;
 
@@ -591,7 +592,8 @@ static int analog_init_port(struct gamep
 		port->mask = (gameport_read(gameport) ^ t) & t & 0xf;
 		port->fuzz = (port->speed * ANALOG_FUZZ_MAGIC) / port->loop / 1000 + ANALOG_FUZZ_BITS;
 
-		for (i = 0; i < ANALOG_INIT_RETRIES; i++) {
+		end_time = jiffies + msecs_to_jiffies(ANALOG_MAX_TIME * ANALOG_INIT_RETRIES);
+		while (time_before(jiffies, end_time)) {
 			if (!analog_cooked_read(port))
 				break;
 			msleep(ANALOG_MAX_TIME);
--- a/drivers/input/keyboard/atkbd.c
+++ b/drivers/input/keyboard/atkbd.c
@@ -150,7 +150,7 @@ static unsigned char atkbd_unxlate_table
 #define ATKBD_RET_EMUL0		0xe0
 #define ATKBD_RET_EMUL1		0xe1
 #define ATKBD_RET_RELEASE	0xf0
-#define ATKBD_RET_HANGUEL	0xf1
+#define ATKBD_RET_HANGEUL	0xf1
 #define ATKBD_RET_HANJA		0xf2
 #define ATKBD_RET_ERR		0xff
 
@@ -304,7 +304,7 @@ static irqreturn_t atkbd_interrupt(struc
 
 		if (atkbd->emul ||
 		    (code != ATKBD_RET_EMUL0 && code != ATKBD_RET_EMUL1 &&
-		     code != ATKBD_RET_HANGUEL && code != ATKBD_RET_HANJA &&
+		     code != ATKBD_RET_HANGEUL && code != ATKBD_RET_HANJA &&
 		     (code != ATKBD_RET_ERR || atkbd->err_xl) &&
 	             (code != ATKBD_RET_BAT || atkbd->bat_xl))) {
 			atkbd->release = code >> 7;
@@ -333,8 +333,8 @@ static irqreturn_t atkbd_interrupt(struc
 		case ATKBD_RET_RELEASE:
 			atkbd->release = 1;
 			goto out;
-		case ATKBD_RET_HANGUEL:
-			atkbd_report_key(atkbd->dev, regs, KEY_HANGUEL, 3);
+		case ATKBD_RET_HANGEUL:
+			atkbd_report_key(atkbd->dev, regs, KEY_HANGEUL, 3);
 			goto out;
 		case ATKBD_RET_HANJA:
 			atkbd_report_key(atkbd->dev, regs, KEY_HANJA, 3);
--- a/drivers/input/misc/hp_sdc_rtc.c
+++ b/drivers/input/misc/hp_sdc_rtc.c
@@ -690,14 +690,24 @@ static struct miscdevice hp_sdc_rtc_dev 
 static int __init hp_sdc_rtc_init(void)
 {
 	int ret;
+	struct proc_dir_entry* proc_de;
 
 	init_MUTEX(&i8042tregs);
 
 	if ((ret = hp_sdc_request_timer_irq(&hp_sdc_rtc_isr)))
 		return ret;
-	misc_register(&hp_sdc_rtc_dev);
-        create_proc_read_entry ("driver/rtc", 0, 0, 
+	ret = misc_register(&hp_sdc_rtc_dev);
+	if (ret) {
+		printk(KERN_WARNING "hp_sdc_rtc: "
+				"Unable to register misc device.\n");
+		return ret;
+	}
+	proc_de = create_proc_read_entry("driver/rtc", 0, 0,
 				hp_sdc_rtc_read_proc, NULL);
+	if (proc_de == NULL) {
+		printk(KERN_WARNING "hp_sdc_rtc: "
+				"Unable to create proc dir entry.\n");
+	}
 
 	printk(KERN_INFO "HP i8042 SDC + MSM-58321 RTC support loaded "
 			 "(RTC v " RTC_VERSION ")\n");
--- a/drivers/isdn/capi/capi.c
+++ b/drivers/isdn/capi/capi.c
@@ -674,13 +674,8 @@ capi_read(struct file *file, char __user
 		if (file->f_flags & O_NONBLOCK)
 			return -EAGAIN;
 
-		for (;;) {
-			interruptible_sleep_on(&cdev->recvwait);
-			if ((skb = skb_dequeue(&cdev->recvqueue)) != 0)
-				break;
-			if (signal_pending(current))
-				break;
-		}
+		wait_event_interruptible(cdev->recvwait,
+				((skb = skb_dequeue(&cdev->recvqueue)) == 0));
 		if (skb == 0)
 			return -ERESTARTNOHAND;
 	}
--- a/drivers/isdn/hardware/eicon/debug.c
+++ b/drivers/isdn/hardware/eicon/debug.c
@@ -756,14 +756,14 @@ int diva_get_driver_info (dword id, byte
 
     data_length -= 9;
 
-    if ((to_copy = MIN(strlen(clients[id].drvName), data_length-1))) {
+    if ((to_copy = min(strlen(clients[id].drvName), data_length-1))) {
       memcpy (p, clients[id].drvName, to_copy);
       p += to_copy;
       data_length -= to_copy;
       if ((data_length >= 4) && clients[id].hDbg->drvTag[0]) {
         *p++ = '(';
         data_length -= 1;
-        if ((to_copy = MIN(strlen(clients[id].hDbg->drvTag), data_length-2))) {
+        if ((to_copy = min(strlen(clients[id].hDbg->drvTag), data_length-2))) {
           memcpy (p, clients[id].hDbg->drvTag, to_copy);
           p += to_copy;
           data_length -= to_copy;
--- a/drivers/isdn/hardware/eicon/io.c
+++ b/drivers/isdn/hardware/eicon/io.c
@@ -262,7 +262,7 @@ void request(PISDN_ADAPTER IoAdapter, EN
     case IDI_SYNC_REQ_XDI_GET_CAPI_PARAMS: {
        diva_xdi_get_capi_parameters_t prms, *pI = &syncReq->xdi_capi_prms.info;
        memset (&prms, 0x00, sizeof(prms));
-       prms.structure_length = MIN(sizeof(prms), pI->structure_length);
+       prms.structure_length = min(sizeof(prms), pI->structure_length);
        memset (pI, 0x00, pI->structure_length);
        prms.flag_dynamic_l1_down    = (IoAdapter->capi_cfg.cfg_1 & \
          DIVA_XDI_CAPI_CFG_1_DYNAMIC_L1_ON) ? 1 : 0;
--- a/drivers/isdn/hardware/eicon/platform.h
+++ b/drivers/isdn/hardware/eicon/platform.h
@@ -228,7 +228,7 @@ void PCIread (byte bus, byte func, int o
 /*
 **  I/O Port utilities
 */
-int diva_os_register_io_port (void *adapter, int register, unsigned long port,
+int diva_os_register_io_port (void *adapter, int on, unsigned long port,
 				unsigned long length, const char* name, int id);
 /*
 **  I/O port access abstraction
--- a/drivers/isdn/hisax/diva.c
+++ b/drivers/isdn/hisax/diva.c
@@ -1101,6 +1101,7 @@ setup_diva(struct IsdnCard *card)
 			bytecnt = 32;
 		}
 	}
+	goto ready; /* Assure that `ready' is used even if `__ISAPNP__' isn't. */
 ready:
 	printk(KERN_INFO
 		"Diva: %s card configured at %#lx IRQ %d\n",
--- a/drivers/isdn/hisax/hisax_fcpcipnp.c
+++ b/drivers/isdn/hisax/hisax_fcpcipnp.c
@@ -997,18 +997,16 @@ static int __init hisax_fcpcipnp_init(vo
 	printk(KERN_INFO "hisax_fcpcipnp: Fritz!Card PCI/PCIv2/PnP ISDN driver v0.0.1\n");
 
 	retval = pci_register_driver(&fcpci_driver);
-	if (retval)
-		goto out;
+	if (! retval)
+	{
 #ifdef __ISAPNP__
-	retval = pnp_register_driver(&fcpnp_driver);
-	if (retval < 0)
-		goto out_unregister_pci;
+		retval = pnp_register_driver(&fcpnp_driver);
+		if (retval < 0)
+			pci_unregister_driver(&fcpci_driver);
+		else
 #endif
-	return 0;
-
- out_unregister_pci:
-	pci_unregister_driver(&fcpci_driver);
- out:
+			retval = 0;
+	}
 	return retval;
 }
 
--- a/drivers/isdn/hisax/isdnhdlc.h
+++ b/drivers/isdn/hisax/isdnhdlc.h
@@ -41,10 +41,10 @@ struct isdnhdlc_vars {
 	unsigned char shift_reg;
 	unsigned char ffvalue;
 
-	int data_received:1; 	// set if transferring data
-	int dchannel:1; 	// set if D channel (send idle instead of flags)
-	int do_adapt56:1; 	// set if 56K adaptation
-        int do_closing:1; 	// set if in closing phase (need to send CRC + flag
+	unsigned int data_received:1; 	// set if transferring data
+	unsigned int dchannel:1; 	// set if D channel (send idle instead of flags)
+	unsigned int do_adapt56:1; 	// set if 56K adaptation
+	unsigned int do_closing:1; 	// set if in closing phase (need to send CRC + flag
 };
 
 
